﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using AsReaderP252BiOSSDK;
using AsReaderP252BSDK;
using CoreAnimation;
using Drastic.MBProgressHUD;
using Foundation;
using SceneKit;
using UIKit;

namespace AsReaderP252BiOSDemo.Platforms.iOS
{
    public class AsReaderP252BMAUIManager
    {

        public class MyAsReaderP252BDeviceManagerDelegate : AsReaderP252BDeviceManagerDelegate
        {
            AsReaderP252BSDelegate asReaderP252BSDelegate = AsReaderP252BSDelegate.sharedInstance();
            public MyAsReaderP252BDeviceManagerDelegate()
            {

            }
            public override void DidDiscoverAsReaderP252BDeviceList(AsReaderP252B[] asReaderP252BList)
            {
                List<AsReaderP252B> list = asReaderP252BList.ToList();
                if (asReaderP252BSDelegate.DidDiscoverAsReaderP252BDeviceList != null)
                {
                    asReaderP252BSDelegate.DidDiscoverAsReaderP252BDeviceList(list);
                }
            }

        }
        public class MyAsReaderP252BDelegate : AsReaderP252BDelegate
        {
            AsReaderP252BSDelegate asReaderP252BSDelegate = AsReaderP252BSDelegate.sharedInstance();
            public MyAsReaderP252BDelegate()
            {

            }
            public override void WhenAsReaderP252BIsConnected(bool isConnected)
            {
                if (isConnected)
                {
                    AsReaderP252BMAUIManager.sharedInstance().isConnect = true;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.Buzzer = AsReaderP252BBuzzerState.AsReaderP252B3Buzzer_High;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.InventoryTime = 40;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.IdleTime = 0;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.AutoOffTime = 300;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.QValue = 4;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.SleepTime = 300;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.LinkProfileValue = 1;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.OperationTime = 0;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.PowerGain = 300;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.InventorySession = AsReaderP252BSessionType.AsReaderP252BSession_S0;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.SessionFlag = AsReaderP252BSessionFlag.Ab;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.ContinuousMode = true;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.RssiMode = false;
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.SetFrequencyAutomatic(true);
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.SetBarcodeTimeOut(4);
                    AsReaderP252BMAUIManager.sharedInstance().asReaderP252B.SetBaudRate(2);
                }
                else
                {
                    AsReaderP252BMAUIManager.sharedInstance().isConnect = false;
                }
                if (asReaderP252BSDelegate.WhenAsReaderP252BIsConnected != null)
                {
                    asReaderP252BSDelegate.WhenAsReaderP252BIsConnected(isConnected);
                }
            }
            public override void ChangedAsReaderP252BActionState(AsReaderP252BCommandType action, nint resultCode)
            {
                if (asReaderP252BSDelegate.ChangedAsReaderP252BActionState != null)
                {
                    asReaderP252BSDelegate.ChangedAsReaderP252BActionState(action, resultCode);
                }
            }
            public override void ReadAsReaderP252BTag(string tag, float rssi, float phase, float frequency)
            {
                if (asReaderP252BSDelegate.ReadAsReaderP252BTag != null)
                {
                    asReaderP252BSDelegate.ReadAsReaderP252BTag(tag, rssi, phase, frequency);
                }
            }
            public override void DetectBarcode(AsReaderP252BBarcodeType barcodeType, NSData barcodeData)
            {
                if (asReaderP252BSDelegate.DetectBarcode != null)
                {
                    string type = AsReaderP252BBarcode.GetBarcodeString(barcodeType);
                    asReaderP252BSDelegate.DetectBarcode(type, barcodeData);
                }
            }
            public override bool OnAsReaderP252BModeKeyEvent(bool status)
            {
                return false;
            }
            public override bool OnAsReaderP252BTriggerKeyEvent(bool status)
            {
                if (asReaderP252BSDelegate.OnAsReaderP252BTriggerKeyEvent != null)
                {
                    return asReaderP252BSDelegate.OnAsReaderP252BTriggerKeyEvent(status);
                }
                else
                {
                    return false;
                }
            }
        }
        AsReaderP252BDeviceManager bluetoothManager;
        AsReaderP252B asReaderP252B;
        private int max;
        private int min;
        public bool isConnect;
        static AsReaderP252BMAUIManager uniqueInstance;
        static readonly object locker = new object();
        public static AsReaderP252BMAUIManager sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP252BMAUIManager();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderP252BMAUIManager()
        {
            isConnect = false;
            bluetoothManager = AsReaderP252BDeviceManager.Shared;
            MyAsReaderP252BDeviceManagerDelegate myAsReaderP252BDeviceManagerDelegate = new MyAsReaderP252BDeviceManagerDelegate();
            bluetoothManager.Delegate = myAsReaderP252BDeviceManagerDelegate;
        }
        public void StartDiscovery()
        {
            bluetoothManager.StartDiscovered();
        }
        public void StopDiscovery()
        {
            bluetoothManager.StopDiscovered();
        }
        public void ConnectDevice(AsReaderP252B asreader)
        {
            if (asreader != null)
            {
                asReaderP252B = asreader;
                MyAsReaderP252BDelegate myAsReaderP252BDelegate = new MyAsReaderP252BDelegate();
                asReaderP252B.SetDelegate(myAsReaderP252BDelegate);
                asReaderP252B.Connect();
            }
        }
        public void DisconnectDevice()
        {
            if (asReaderP252B != null)
            {
                asReaderP252B.Disconnect();
            }
        }
        public string GetAPPVersion()
        {
            return GetAppVersion() + " (" + GetAPPBuild() + ")";
        }
        private string GetAppVersion()
        {
            return NSBundle.MainBundle.InfoDictionary["CFBundleShortVersionString"].ToString();
        }
        private string GetAPPBuild()
        {
            return NSBundle.MainBundle.InfoDictionary["CFBundleVersion"].ToString();
        }
        public string GetSDKVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return AsReaderP252B.SDKVersion;
            }
        }
        public string GetFirmwareVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return asReaderP252B.FirmwareVersion;
            }
        }
        public string GetRFModuleVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return asReaderP252B.RFModuleVersion;
            }
        }
        public string GetRegion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return asReaderP252B.RegionName;
            }
        }
        public string GetSerialNumber()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return asReaderP252B.SerialNumber;
            }
        }
        public int GetBatteryStatus()
        {
            if (GetAsReaderStatus() == false)
            {
                return 0;
            }
            else
            {
                return asReaderP252B.BatteryStatus;
            }
        }
        public void StartDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BResultCode resultCode = asReaderP252B.StartDecode;
            }
        }
        public void StopDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BResultCode resultCode = asReaderP252B.StopSync;
            }
        }
        public void Inventory()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BResultCode resultCode = asReaderP252B.Inventory;
            }
        }
        public void Stop()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BResultCode resultCode = asReaderP252B.Stop;
            }
        }
        public int PowerGain
        {
            get
            {
                if (GetAsReaderStatus() == false)
                {
                    return 5;
                }
                return asReaderP252B.PowerGain;
            }
            set
            {
                if (GetAsReaderStatus() == false)
                {
                    return;
                }
                asReaderP252B.PowerGain = value;
            }
        }
        public ArrayList GetPowerGainRange()
        {
            ArrayList mList = new ArrayList();
            if (GetAsReaderStatus() == true)
            {
                min = asReaderP252B.PowerGainRange.min;
                max = asReaderP252B.PowerGainRange.max;

                for (int i = min; i <= max; i += 10)
                {
                    mList.Add((i / 10).ToString() + ".0 dB");
                }
            }
            return mList;
        }
        public int GetPowerRangeMax()
        {
            return max;
        }
        public int GetPowerRangeMin()
        {
            return min;
        }
        public void SetContinuousMode(bool enabled)
        {
            if (GetAsReaderStatus() == true)
            {
                asReaderP252B.ContinuousMode = enabled;
            }
        }
        public bool GetAsReaderStatus()
        {
            if (asReaderP252B != null && isConnect)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public AsReaderP252BScanMode GetScanMode()
        {
            return asReaderP252B.ScanMode;
        }
        public void SetScanMode(AsReaderP252BScanMode scanMode)
        {
            if (GetAsReaderStatus() == true)
            {
                asReaderP252B.SetScanMode(scanMode);
            }
        }
        public string GetAsReaderP25BSDKDLL()
        {
            return AsReaderP252BSDKDLL.DLLVersion();
        }
        public void ShowGlobalProgressHUDWithTitle(string title)
        {
            UIWindow window = UIApplication.SharedApplication.KeyWindow;
            MBProgressHUD hud = MBProgressHUD.ShowHUDAddedTo(window, true);
            hud.Label.Text = title;
            hud.Mode = MBProgressHUDMode.Text;
            CATransaction.Commit();
        }
        public void DismissGlobalHUD()
        {
            UIWindow window = UIApplication.SharedApplication.KeyWindow;
            MBProgressHUD.HideHUDForView(window, true);
            CATransaction.Commit();
        }
    }
}
