﻿namespace AsReaderP252BiOSDemo
{
    public class RFIDCell : ViewCell
    {
        Label rfidLabel, countLabel;

        public static readonly BindableProperty RfidProperty = BindableProperty.Create("Rfid", typeof(string), typeof(RFIDCell), "Rfid");
        public static readonly BindableProperty CountProperty = BindableProperty.Create("Count", typeof(int), typeof(RFIDCell), 0);

        public string Rfid
        {
            get { return (string)GetValue(RfidProperty); }
            set { SetValue(RfidProperty, value); }
        }

        public int Count
        {
            get { return (int)GetValue(CountProperty); }
            set { SetValue(CountProperty, value); }
        }

        public RFIDCell()
        {
            rfidLabel = new Label { TextColor = Color.FromArgb("#000000"), FontSize = 16, HorizontalOptions = LayoutOptions.Start };
            countLabel = new Label { TextColor = Color.FromArgb("#000000"), FontSize = 16, HorizontalOptions = LayoutOptions.Start };

            StackLayout rfidLayout = new StackLayout
            {
                Padding = new Thickness(10, 0, 10, 0),
                Orientation = StackOrientation.Horizontal,
                HorizontalOptions = LayoutOptions.Start,
                Children = { rfidLabel }
            };

            StackLayout countLayout = new StackLayout
            {
                Padding = new Thickness(10, 0, 10, 0),
                Orientation = StackOrientation.Horizontal,
                HorizontalOptions = LayoutOptions.Start,
                Children = { countLabel }
            };

            var viewLayout = new StackLayout()
            {
                Orientation = StackOrientation.Vertical,
                Children = { rfidLayout, countLayout }
            };
            View = viewLayout;
        }

        protected override void OnBindingContextChanged()
        {
            base.OnBindingContextChanged();

            if (BindingContext != null)
            {
                rfidLabel.Text = Rfid;
                countLabel.Text = Count.ToString();
            }
        }
    }
}

